{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P-,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit ChartInterface01;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, TeeURL, TeeSeriesTextEd, Series, ExtCtrls, TeeProcs,
  Chart, StdCtrls, CurvFitt, TeeEdit;

type
  TChartDisplay = class(TForm)
    bnGetData: TButton;
    bnSaveJPG: TButton;
    Chart1: TChart;
    LifeTempData: TSeriesTextSource;
    TTeeFunction1: TCurveFittingFunction;
    bnConvert: TButton;
    ChartEditor1: TChartEditor;
    bnEdit: TButton;
    bnSaveChart: TButton;
    bnLoadChart: TButton;
    SerArrheniusFit: TFastLineSeries;
    bnFit: TButton;
    serLifeTempC: TPointSeries;
    procedure bnGetDataClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bnSaveJPGClick(Sender: TObject);
    procedure bnConvertClick(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
    procedure bnEditClick(Sender: TObject);
    procedure bnSaveChartClick(Sender: TObject);
    procedure bnLoadChartClick(Sender: TObject);
    procedure serLifeTempCGetMarkText(Sender: TChartSeries;
      ValueIndex: Integer; var MarkText: String);
    procedure bnFitClick(Sender: TObject);
  private
    { Private declarations }
  public
    AbscissaConverted : boolean;
  end;

var
  ChartDisplay: TChartDisplay;

implementation

uses dmChartUtils, fmGetTextFile, UcPos; {Math32,}

{$R *.dfm}

{ TODO :
Questions for teeChart support
  How/where does curve fitter report parameters?
  Issues of polydgree = 1 as reported in forum
    Fixed in v. 8?
  Point series connected by a line at design time,
  but not at runtime?
function for 1000/TK
Linear fit
R-t curves fitting
Add hints
curve fit  stats for v. 5??
Marks when converted
Conversion to new series
Get temps from old series and add to marks in new
ShowHints := true in app and forms
How to extrapolate the linear fit?? Curve fit params? Can we get points from
the series??
 }

procedure TChartDisplay.bnGetDataClick(Sender: TObject);
begin
(*
  // From Help on web
  with LifeTempData do
  begin
    // Setup fields (columns in text file)
    Fields.Clear;
    AddField('X',1);
    AddField('Y',2);

    // Set separators
    FieldSeparator := ' ';
    DecimalSeparator := '.';

    // Series to add data
    Series := SerLifeTempC;

    // Load data from file into Series
    Active := True;
  end;
*)
  GetDataFile.Visible := true
end;

procedure TChartDisplay.FormCreate(Sender: TObject);
begin
  tTeeFunction1.PolyDegree := 2;
  tTeeFunction1.AddPoints( serLifeTempC )
end;

procedure TChartDisplay.bnSaveJPGClick(Sender: TObject);
  { Grab the save dialog form from ISC plotter }
var tps, s1 : string; SerNr : integer;

begin
  SerNr := 0;
  s1 := GetCurrentDir + '\' + 'teeChartPlot';
  tps := s1;
  While FileExists( s1 + IntToStr( SerNr ) + '.jpg' ) do begin
    inc( SerNr );
    tps := s1 + IntToStr( SerNr );
  end;
  With ChartCom.GetChartJPEG(Chart1) do
  try
    SaveToFile( tps + '.jpg' );    { <-- save the JPEG to disk }
  finally
    Free;  { <-- free the temporary JPEG object }
  end;
end;

procedure TChartDisplay.bnConvertClick(Sender: TObject);

var x : double; i, tpi : longint;

begin
  With SerLifeTempC do begin
    for i := 0 to count-1 do begin
      x := xValue[ i ];
      x := 1000 /( xValue[ i ] + 273 );
      xValue[ i ] := x
    end;
    with Chart1.axes.Items[ 3 ] do begin
(*
      { left, top, right, bottom, depth  }
      tpi := round( xValue[ 0 ]);
      if tpi > xvalue[ 0 ] then dec( tpi );
      StartPosition := tpi; { mthRoundDownOne( xValue[ 0 ])}
      tpi := round( xValue[ count ]);
      if tpi < xvalue[ count ] then inc( tpi );
      EndPosition := tpi; { mthRoundUp( xValue[ Count ]); }
      x := xValue[ 0 ] * 0.96;
      StartPosition := xValue[ 0 ] * 0.96;
      x := xValue[ count ] * 1.04;
      EndPosition := xValue[ count ] * 1.04;
*)      
      inverted := true
    end;
  end;
  bnConvert.Enabled := false;
  AbscissaConverted := true
end;

procedure TChartDisplay.Chart1DblClick(Sender: TObject);
begin
  ChartEditor1.Execute
end;

procedure TChartDisplay.bnEditClick(Sender: TObject);
begin
  ChartEditor1.Execute
end;

procedure TChartDisplay.bnSaveChartClick(Sender: TObject);
begin
(*
With SaveDialog1 do
begin
   Filter:='Teefiles|*.tee';
   if Execute then SaveChartToFile(Chart1,SaveDialog1.FileName,True);
end;
*)
end;

procedure TChartDisplay.bnLoadChartClick(Sender: TObject);

// var tmpChart : TCustomChart;

begin
(*
  Chart1.Free;   //assuming Chart1 is already on the Form
  tmpChart := TChart.Create(Self);
  With OpenDialog1 do begin
    Filter:= 'Teefiles|*.tee';
    if Execute then LoadChartfromFile(tmpChart,OpenDialog1.FileName);
  end;
  Chart1 := tmpChart as TChart;
  With Chart1 do begin
    Parent:=Self;
  end;
*)
end;

procedure TChartDisplay.serLifeTempCGetMarkText(Sender: TChartSeries;
  ValueIndex: Integer; var MarkText: String);

var x : longint;

begin
  with serLifeTempC do
    x := round( 1000 / xValue[ ValueIndex ] -273 );
  MarkText := IntToStr( x ) + 'C';
  { end }
end;

procedure TChartDisplay.bnFitClick(Sender: TObject);
begin
  tTeeFunction1.PolyDegree := 1;
  tTeeFunction1.AddPoints( serLifeTempC )
end;

end.

