{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit dmChartUtils;

interface

uses
  Chart, Classes, Graphics, Jpeg, Math, SysUtils ;

type
  TChartCommon = class(TDataModule)
  Function GetChartJPEG(AChart:TCustomChart):TJPEGImage;
  function  SaveThisChart( theChart : tCustomChart;
                           OverWrite : boolean;
                           ChartPath : string;
                           var TheName : string ) : boolean;
    // Append date; add jpg if needed
    // Saves jpg and cht versions
  function SaveChart( TheChart : tCustomChart;
                      OverWrite : boolean;
                      fName : string ) : boolean;
    // user and date in path, and jpg extension expected
    // saves jpg and cht versions;
  private
    { Private declarations }
  public
    // AbscissaConverted : boolean; don'g think we need this...
    DataSourceFileName : string;
  end;

var
  ChartCom: TChartCommon;

implementation

{$R *.dfm}

uses Controls, Dialogs, { FileSvc95, } TeeStore {, ucString };

function TChartCommon.SaveThisChart( theChart : tCustomChart;
                        OverWrite : boolean;
                        ChartPath : string;
                        var TheName : string ) : boolean;

var
  lgt : word;
  Fname,       // fully qualified path and extension to save IMAGE
  thePath,
  tps : string;

begin     { SaveThisChart }
  // blank option added 06-20-2005
  tps := '';
  Fname := '';
  // if ChartPath <> '' then tps := flPathByDate( ChartPath ); 10-24-2009
  if ChartPath <> '' then tps := GetCurrentDir;
    // create if does not exist
  if pos ( '.jpg', TheName ) <> length( TheName ) - 3 then
    TheName := TheName + '.jpg';
  fname := tps + TheName;
  thePath := ExtractFileDir( fName ) + '\';
  Lgt := Length( ThePath );
    // we don't print the .jpg; that is in the interface as static text label.
  TheName := copy( fName, lgt + 1, Length( fName ) - ( lgt + 4 ));
  Result := SaveChart( TheChart, OverWrite, fName );
end;      { SaveThisChart }

function TChartCommon.SaveChart( TheChart : tCustomChart;
                    OverWrite : boolean;
                    fName : string ) : boolean;

var DoSave : boolean; ChartFname : string;

begin
  DoSave :=
    ( not FileExists( fName ))
    or OverWrite
    or ( MessageDlg( 'File ' + fName + ' exists; overwrite?',
      mtConfirmation, [mbYes, mbNo], 0 ) = mrYes );
    { end }
  if DoSave then
  with GetChartJPEG( theChart ) do
    try
      SaveToFile( fName );    { <-- save the JPEG to disk }
    finally
      Free;  { <-- free the temporary JPEG object }
    end;
  ChartfName := copy( fName, 1, Pos( '.', fName )) + 'cht';
    // And finally, save the CHART (not the image) with its dataset (true)
  SaveChartToFile( theChart, ChartFname, true );
    // Note that, as written, chart and dataset are saved to the file
    // and, presumably, an existing .cht file is overwritten.
  Result := DoSave;
end;      { SaveChart }

Function TChartCommon.GetChartJPEG;

var tmpBitmap:TBitmap;

begin
  result:=TJPEGImage.Create;   { <-- create a TJPEGImage }
  tmpBitmap:=TBitmap.Create;   { <-- create a temporary TBitmap }
  try
    tmpBitmap.Width := AChart.Width;   { <-- set the bitmap dimensions }
    tmpBitmap.Height:= AChart.Height;
    { draw the Chart on the temporary Bitmap... }
    AChart.Draw(tmpBitmap.Canvas,Rect(0,0,tmpBitmap.Width,tmpBitmap.Height));
    { set the desired JPEG options... }
    With result do
    begin
      GrayScale            :=False;
      ProgressiveEncoding  :=True;
      CompressionQuality   :=100;  // % 0 - 100
      PixelFormat          :=jf24bit;  // or jf8bit
      ProgressiveDisplay   :=True;
      Performance          :=jpBestQuality;  // or jpBestSpeed
      Scale                :=jsFullSize;  // or jsHalf, jsQuarter, jsEighth
      Smoothing            :=True;
        // Copy the temporary Bitmap onto the JPEG image...
      Assign(tmpBitmap);
    end;
  finally
    tmpBitmap.Free;  { <-- free the temporary Bitmap }
  end;
end;      { GetChartJpeg }

end.
